//PIN_PWM=9;TIM1
//PIN_PWM=2;TIM2
//CNT_IN=5;
//AIN As (A1..A3)
//DIN PDs (0..7) 01RxTx; six workin'


//T1:
/*cnt as cnt and not sw
  watchdog; maybe for slow measuements
  scope single, more for trigger pre, ch2; ch3?
  scope protocol - disable non-la features for la
*/
#include <compat/deprecated.h>
#define F_CPU 16000000UL //not necessary
#define BAUD 115200

#include "T1.h"
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/io.h>
#include <util/setbaud.h>


#define CHBAS 0
#define CHOSC 1
#define CHPWM 2
#define CHVM 3
#define CHCNT 4

unsigned char c;
unsigned int i;
unsigned char sbuffer[256] = {};
unsigned char sbufferlen = 0;
unsigned char offset = 0;
unsigned long long voltage[5] = {};
unsigned long svoltage[5] = {};
unsigned char * voltdat = (unsigned char*)svoltage + 2;
uint8_t conf = 0; //0..3
const unsigned char caps[4] PROGMEM = {13, 7, 21, 7};

unsigned long nextmeas = 0;
unsigned long t1val;
long duty = 512;
//TIM2
unsigned char pwmPre = 6;
unsigned char pwmPer = 255;
unsigned char pwmDut = 50; //0-100
//VM
unsigned char vmRun = 0;
unsigned char vmSample[2];
const unsigned char str[5][16] PROGMEM = { "ATmega328", "VM_PWM1", "OS_PWM1", "C__PWM2", "LA_PWM1"}; //four

//SCOPE
//unsigned char scCh = 1;//std <<
//unsigned char triggerCh = 1;
//pretrigger,
unsigned char scRun = 0;
unsigned char samples[768];//main mem
unsigned int sample = 0;//mem index
unsigned long scLastSa = 0;//
unsigned long scPeriod = 1000;
unsigned char triggerState = 3;//1 dn, 2 up, 3 run! 0 undef
unsigned char scTrigger = 1;//0 auto, 1 r, 2 f 3 rf
unsigned char aTrigger = 0;//auto trigger
unsigned int triggerLevel = 512; //triggerTODO
uint8_t scCh = 1;
uint16_t schBufferLen = 768;


unsigned char counting = 0;
unsigned long period(uint8_t pin, uint8_t state);
//unsigned long freq();
uint32_t cntPeriod = 0;
unsigned char* cntPeC = (unsigned char*)(&cntPeriod);
uint32_t cntDuty = 1;
unsigned char* cntDuC = (unsigned char*)(&cntDuty);
uint32_t cntFreqD = 1e6;
unsigned char* cntFreq = (unsigned char*)(&cntFreqD);

//functions
void setupCallback();
void voltLoop();
void scopeLoop();
void cntLoop();
void laLoop();

void sendBin(unsigned char ch, unsigned char len, unsigned char* data) {
  Serial.write(0xFF); Serial.write(ch); Serial.write((char)len & 0xff); Serial.write((char)len & 0xff00);
  for (c = 0; c < len; ++c) Serial.write(data[c]);
}

unsigned int getVcc() {
  ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  delay(1); // Wait for Vref; bit to much?
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA, ADSC));
  return 1126400 / ADC; //1.1*1024/ADC-theoretical
  //return 1101237/ADC;//calibrated value for current testing board
}



void sendT2Val() {
  Serial.write(0xFE);
  Serial.write(0x0); Serial.write(0x12); Serial.write(0x7A); Serial.write(0);
  Serial.write('F'); Serial.write(CHPWM);
  unsigned long t1val = OCR2A;//dont know why 2 times bigger than expected
  switch (pwmPre) {
    case 7:
      t1val <<= 9;
      break;
    case 6:
      t1val <<= 7;
      break;
    case 5:
      t1val <<= 6;
      break;
    case 4:
      t1val <<= 5;
      break;
    case 3:
      t1val <<= 4;
      break;
    case 2:
      t1val <<= 2;
      break;
    case 1:
      t1val >>= 1;
    default:
      break;
  }
  Serial.write(0xFE);
  Serial.write((char)(t1val & 0xff)); Serial.write((char)((t1val & 0xff00) >> 8)); Serial.write((char)((t1val & 0xff0000) >> 16)); Serial.write((char)((t1val & 0xff000000) >> 24));
  Serial.write('D'); Serial.write(CHPWM);
}

void changeTIM2(unsigned long freq) {
  TCCR2B = 8;//pwm disabled
  TCNT2 = 0;

  if (freq & (0x1 << 14)) {
    freq = 1000 * (freq & 0x3FFF);
  }
  else if (freq & (0x2 << 14)) {
    freq = 1000000 * (freq & 0x3FFF);
  }
  //freq now cycles
  if (freq < 62) {
    pwmPre = 7;
    pwmPer = 255;
  }
  else if (freq < 245) {
    pwmPre = 7;
    pwmPer = 16000000 / (freq << 10);
  }
  else if (freq < 489) {
    pwmPre = 6;
    pwmPer = 16000000 / (freq << 8);
  }
  else if (freq < 977) {
    pwmPre = 5;
    pwmPer = 16000000 / (freq << 7);
  }
  else if (freq < 1954) {
    pwmPre = 4;
    pwmPer = 16000000 / (freq << 6);
  }
  else if (freq < 7813) {
    pwmPre = 3;
    pwmPer = 16000000 / (freq << 5);
  }
  else if (freq < 62500) {
    pwmPre = 2;
    pwmPer = 16000000 / (freq << 3);
  }
  else if (freq >= 62500) {
    pwmPre = 1;
    pwmPer = 16000000 / freq;
  }
  OCR2A = pwmPer;
  OCR2B = pwmPer * pwmDut / 100;
  TCCR2B = pwmRun ? (8 | pwmPre) : 8;
  sendT2Val();
}


void processBuffer() {
  if (sbuffer[offset] == 0xFE) {
    switch (sbuffer[(offset + 6) & 0xff]) {
      case CHBAS:
        if (sbuffer[(offset + 5) & 0xff] == 'C') offset += 6;
        if (sbuffer[(offset + 5) & 0xff] == 'G') {
          if (sbuffer[(offset + 1) & 0xff] == 'N') {

            Serial.write(0xFF); Serial.write(CHBAS); Serial.write(10); Serial.write(0);
            for (c = 0; c < 9; ++c)Serial.write(pgm_read_byte_near((*str) + c)); Serial.write(0);
            conf = (conf + 1) & 3;
            offset += 6;
          }
          if (sbuffer[(offset + 1) & 0xff] == 'V') {
            i = getVcc();
            Serial.write(0xFF); Serial.write(CHBAS); Serial.write(4); Serial.write(0);
            Serial.write(i & 0x00ff); Serial.write((i & 0xff00) >> 8);
            Serial.write(0); Serial.write(0);
            offset += 6;
          }
          if (sbuffer[(offset + 1) & 0xff] == 'C') { //TODO

            Serial.write(0xFF); Serial.write(CHBAS); Serial.write(7); Serial.write(0);
            for (c = 0; c < 6; ++c)Serial.write(pgm_read_byte_near(str[conf + 1] + c)); Serial.write(0);
            offset += 6;
          }
          if (sbuffer[(offset + 1) & 0xff] == 'F') { //TODO
            Serial.write(0xFF); Serial.write(CHBAS); Serial.write(4); Serial.write(0);
            Serial.write(pgm_read_byte_near(caps + conf));
            Serial.write(0); Serial.write(0); Serial.write(0);
            setupCallback();
            offset += 6;
          }
        }
        else offset += 1;
        break;
      case CHPWM:
        if (conf != 2) {
          switch (sbuffer[(offset + 5) & 0xff]) {
            case 'F'://freq
              changefreq((unsigned long)(sbuffer[(offset + 1) & 0xff] + (sbuffer[(offset + 2) & 0xff] << 8) + (sbuffer[(offset + 3) & 0xff] << 16) + (sbuffer[(offset + 4) & 0xff] << 24)));
              offset += 6;
              break;
            case 'D'://duty-cyc
              TCCR1A &= ~_BV(COM1A1);
              pwmDC = ((long)((sbuffer[(offset + 1) & 0xff]) | (sbuffer[(offset + 2) & 0xff] & 0x3) << 8)) * 1023 / 1000;
              setPWMDuty(pwmDC);
              if (pwmRun) TCCR1A |= _BV(COM1A1);
              offset += 6;
              break;
            case 'S'://start-stop
              pwmRun = sbuffer[(offset + 1) & 0xff];
              if (pwmRun) TCCR1A |= _BV(COM1A1);
              else TCCR1A &= ~_BV(COM1A1);
              offset += 6;
              break;
            default:
              offset += 6;
              break;
          }
        }
        else {
          switch (sbuffer[(offset + 5) & 0xff]) {
            case 'F'://freq
              changeTIM2((unsigned long)(sbuffer[(offset + 1) & 0xff] + (sbuffer[(offset + 2) & 0xff] << 8) + (sbuffer[(offset + 3) & 0xff] << 16) + (sbuffer[(offset + 4) & 0xff] << 24)));
              offset += 6;
              break;
            case 'D'://duty-cyc
              pwmDut = ((((sbuffer[(offset + 1) & 0xff])) | (sbuffer[(offset + 2) & 0xff] & 0x3) << 8)) / 10;

              if (!pwmDut)   TCCR2A = (1 << WGM21) | (1 << WGM20);  // zero correction to not be a short pulse
              else   TCCR2A = (1 << WGM21) | (1 << WGM20) | (1 << COM2B1); // TCCR2A = pwmDut ? 0x23: 0x3;

              OCR2B = pwmPer * pwmDut / 100;
              TCCR2B = pwmRun ? (8 | pwmPre) : 8;
              offset += 6;
              break;
            case 'S'://start-stop
              pwmRun = sbuffer[(offset + 1) & 0xff];
              TCCR2B = pwmRun ? (8 | pwmPre) : 8;
              offset += 6;
              break;
            default:
              offset += 1;
              break;
          }
        }
        break;
      case CHVM:
        if (conf == 0) {
          switch (sbuffer[(offset + 5) & 0xff]) {
            case 'A'://average
              *vmSample = sbuffer[(offset + 1) & 0xff]; //only 8 bit
              offset += 6;
              break;
            case 'S'://start-stop
              vmRun = sbuffer[(offset + 1) & 0xff];
              if (vmRun) {
                nextmeas = millis();
              }
              offset += 6;
              break;
            default:
              offset += 1;
              break;
          }
        }
        else offset += 1;
        break;
      case CHOSC:
        if (conf & 1) { //2nd or 4th conf
          switch (sbuffer[(offset + 5) & 0xff]) {
            case 'S'://start-stop
              scRun = sbuffer[(offset + 1) & 0xff];
              if (scRun) {
                scLastSa = micros();
                Serial.write(0xFE);
                Serial.write((char)((1000000) & 0xff));
                Serial.write((char)(((1000000) & 0xff00) >> 8));
                Serial.write((char)(((1000000) & 0xff0000) >> 16));
                Serial.write((char)(((1000000) & 0xff000000) >> 24));
                Serial.write('F'); Serial.write(CHOSC);
                Serial.write(0xFE);
                Serial.write((char)((scPeriod) & 0xff));
                Serial.write((char)(((scPeriod) & 0xff00) >> 8));
                Serial.write((char)(((scPeriod) & 0xff0000) >> 16));
                Serial.write((char)(((scPeriod) & 0xff000000) >> 24));
                Serial.write('D'); Serial.write(CHOSC);
              }
              offset += 6;
              break;
            case 'F'://freq Hz
              scPeriod = (unsigned long)( (sbuffer[(offset + 1) & 0xff] + (sbuffer[(offset + 2) & 0xff] << 8) + (sbuffer[(offset + 3) & 0xff] << 16) + (sbuffer[(offset + 4) & 0xff] << 24)));

              if (not (scPeriod & (0x3 << 14)))  scPeriod = 1000000 / scPeriod;
              else if (scPeriod & (0x1 << 14)) scPeriod = 1000 / (scPeriod & 0x3FFF);
              if (conf & 2) {
                if (scPeriod < 13) scPeriod = 13;
              }
              else {
                if (scPeriod < 25) scPeriod = 25;
              }
              if (!(conf & 2) && (scCh == 3) && (scPeriod < 40)) scPeriod = 40;
              //send back real; saturation
              Serial.write(0xFE);
              Serial.write((char)((scPeriod) & 0xff));
              Serial.write((char)(((scPeriod) & 0xff00) >> 8));
              Serial.write((char)(((scPeriod) & 0xff0000) >> 16));//TODO edit to std
              Serial.write((char)(((scPeriod) & 0xff000000) >> 24));
              Serial.write('D'); Serial.write(CHOSC);
              offset += 6;
              break;
            case 'T'://trigger level mV
              triggerLevel = ((sbuffer[(offset + 1) & 0xff]) + ((sbuffer[(offset + 2) & 0xff]) << 8)) * 0.267;
              offset += 6;
              break;
            case 'R'://trigger ch;TODO
              offset += 6;
              break;
            case 'D': //pretrigger ;TODO
              offset += 6;
              break;
            case 'M'://1->auto 0->r/f;TODO
              aTrigger = sbuffer[(offset + 1) & 0xff];
              offset += 6;
              break;
            case 'P'://1->R 2->F
              scTrigger = sbuffer[(offset + 1) & 0xff];
              offset += 6;
              break;
            case 'C':
              scCh = sbuffer[(offset + 1) & 0xff];
              if ((scCh == 3) && (scPeriod < 30)) scPeriod = 30; //prove
              offset += 6;
              break;
            case 'B':
              if((sbuffer[(offset + 1) & 0xff]) + ((sbuffer[(offset + 2) & 0xff]) << 8)>767) schBufferLen = 768;
              else schBufferLen = sbuffer[(offset + 1) & 0xff] + ((sbuffer[(offset + 2) & 0xff]) << 8);
              offset += 6;
              break;
            default:
              offset += 1;
              break;
          }
        }
        else offset += 1;
        break;
      case CHCNT:
        if (conf == 2) {
          if (sbuffer[(offset + 5) & 0xff] == 'S') counting = sbuffer[(offset + 1) & 0xff];
          scLastSa = micros();
          offset += 6;
        }
        else offset += 6;
        break;
      default:
        offset += 1;
        break;
    }
  }
  else offset += 1;
}



void setup() {
  Serial.begin(115200);
  Serial.write(0xFF); Serial.write(CHBAS); Serial.write(8); Serial.write(0);//send config to PC (typical is reset during setup)
  for (char i = 0; i < 7; ++i)Serial.write(pgm_read_byte_near(str[0] + i)); Serial.write(0);
  ADCSRA = (ADCSRA & B11111000) | 3;
  pwmRun = 0;
}
unsigned char j;
void loop() {
  while (Serial.available()) {
    j = Serial.available();
    for (; j != 0; --j) {
      sbuffer[sbufferlen] = Serial.read();
      ++sbufferlen;
    }
  }
  while (((sbufferlen - offset + 0xff + 1) & 0xff) > 6) processBuffer();

  switch (conf) { //FUNCTIONAL INIT
    case 0://VM loop
      voltLoop();
      break;
    case 1://OSC loop
      scopeLoop();
      break;
    case 2://CNT loop
      cntLoop();
      break;
    case 3://LA lool
      laLoop();
      break;
    default:
      break;
  }

}
void voltLoop() {
  if (vmRun && (nextmeas + 10 < millis())) { //time for measure; in future rewrite with overflow tag of counter
    nextmeas += 10;
    ADCSRA = (ADCSRA & B11111000) | 7;
    voltage[1] += analogRead(A0);
    voltage[2] += analogRead(A1);
    voltage[3] += analogRead(A2);
    voltage[4] += getVcc();
    ++vmSample[1];//sampling
    //sendBin(CHVM, 18 , voltdat);
  }

  if (vmSample[0] <= vmSample[1]) {
    voltdat[0] = vmSample[1];//vmSample[1];//set to 1
    svoltage[4] = (unsigned long)(voltage[4]);///vmSample[1]
    voltage[4] = 0;//vmSample[1];
    for (char i = 1; i < 4; ++i) {
      svoltage[i] = (unsigned long)(voltage[i] * svoltage[4] * 0.001212121212 / vmSample[1]); //vcc correction*(4*5/3.3)/5000
      voltage[i] = 0;
    }
    vmSample[1] = 0;
    sendBin(CHVM, 18 , voltdat);
  }
}

void scopeLoop() {
  if (scRun && (sample == 0)) {
    if (scPeriod < 50) {
      ADCSRA = (ADCSRA & B11111000) | 3;
    }
    else {
      if (scPeriod < 100) {
        ADCSRA = (ADCSRA & B11111000) | 4;
      }
      else {
        if (scPeriod < 200) {
          ADCSRA = (ADCSRA & B11111000) | 5;
        }
        else {
          if (scPeriod < 400) {
            ADCSRA = (ADCSRA & B11111000) | 6;
          }
          else {
            ADCSRA = (ADCSRA & B11111000) | 7;
          }
        }
      }
    }
    if (aTrigger) triggerState = 3;
    else {
      switch (scTrigger) {
        case 0:
          break;
        case 1://R
          if (analogRead(A0) >= triggerLevel) {
            if (triggerState == 1) triggerState = 3;
            else triggerState = 2;
          }
          else triggerState = 1;
          break;
        case 2://F
          if (analogRead(A0) <= triggerLevel) {
            if (triggerState == 2) triggerState = 3;
            else triggerState = 1;
          }
          else triggerState = 2;
          break;
        case 3://RF
          if ((analogRead(A0) >= triggerLevel)) {
            if (triggerState == 1) triggerState = 3;
            else triggerState = 2;
          }
          else {
            if (triggerState == 2) triggerState = 3;
            else triggerState = 1;
          }
          break;
        default:
          break;
      }
    }
    scLastSa = micros();
  }
  if (scRun && (scLastSa <= micros()) && (triggerState == 3)) { //10kHz, single

    if (scCh & 1) {
      { ADMUX = (1 << 5) |(1 << 6) | (0 & 0x07);
        sbi(ADCSRA, ADSC);
        c = 1 << ((ADCSRA & 0x7) + 1);
        while (c)--c;
        if (scCh & 2) ADMUX = (1 << 5) |(1 << 6) | (1 & 0x07);
        while (bit_is_set(ADCSRA, ADSC));
        samples[sample] = ADCH;
      }
      //samples[sample] = (char)((analogRead(A0)) >> 2);
      ++sample;
    }
    if (scCh & 2) {
      { ADMUX = (1 << 5) |(1 << 6) | (1 & 0x07);
        sbi(ADCSRA, ADSC);
        c = 1 << ((ADCSRA & 0x7) + 1);
        while (c)--c;
        if (scCh & 1) ADMUX = (1 << 5) |(1 << 6) | (0 & 0x07);
        while (bit_is_set(ADCSRA, ADSC));
        samples[sample] = ADCH;
      }
      //samples[sample] = (char)((analogRead(A0)) >> 2);
      ++sample;
    }
    scLastSa += scPeriod;
  }
  if (scRun && (sample >= schBufferLen)) { //end of buffer => send//sendbin//TODO shorter buffer opt
    Serial.write(0xFF); Serial.write(CHOSC); Serial.write((char)(((schBufferLen+1)<<1)&0xff)); Serial.write((char)(((schBufferLen+1)&0x7f80)>>7));
    Serial.write((char)1);
    if (scCh == 3) Serial.write((char)40);
    else Serial.write((char)24);
    for (i = 0; i < schBufferLen; ++i) {
      Serial.write((char)((samples[i]) << 4));
      Serial.write((char)((samples[i]) >> 4));
    }
    sample = 0;
    triggerState = 0;
    if (scRun == 2) scRun = 0;
  }
};
void setupCallback() {
  pwmRun = 0;
  vmRun = 0;
  scRun = 0;
  counting = 0;
  if (conf != 2) { //INIT PWM1
    TCCR2B = 8;//pwm2 disabled

    TCCR1A = 0;
    TCCR1B = _BV(WGM13);//Phase correct pwm
    t1Period(1000UL);
    pinMode(9, OUTPUT);
    pwmRun = 0;
    TCCR1A &= ~_BV(COM1A1);//stopPwm
    pwmDC = 512;
    setPWMDuty(512);//set 50% duty cyc
    changefreq(100);
    sendTimerVal();

  } else { //INIT PWM2
    TCCR1A &= ~_BV(COM1A1);//stopPwm1

    //DDRD |= (1 << PD3);// set 3 as output
    pinMode(3, OUTPUT);
    TCCR2A = (1 << WGM21) | (1 << WGM20) | (1 << COM2B1); // Fast PWM
    TCCR2B = 8;//pwm disabled

    TCNT2 = 0;
    OCR2A = 255;
    OCR2B = 50;//pwm duty cycle at 50 %
    sendT2Val();
  }//sending timer2 val
  if(conf!=1) ADMUX &= ~(1 << 5);
  switch (conf) { //FUNCTIONAL INIT
    case 0:
      *vmSample = 1;
      *(vmSample + 1) = 0;
      break;
    case 3:
      pinMode(3, INPUT);
    default:
      break;
  }
}

void laLoop() {
  //if (scRun && (scLastSa <= micros()) && (triggerState == 3)) { //10kHz, single
  if (scRun && (scLastSa <= micros())) { //edited addec old up
    samples[sample] = PIND;//edited
    ++sample;
    scLastSa += scPeriod;
  }
  if (scRun && (sample == 768)) { //end of buffer => send//sendbin
    Serial.write(0xFF); Serial.write(CHOSC); Serial.write((char)(3) & 0xff); Serial.write((char)6);
    Serial.write((char)2); Serial.write((char)20); Serial.write((char)21);//edited
    for (i = 0; i < 768; ++i) Serial.write('\0');
    for (i = 0; i < 768; ++i) {
      Serial.write(samples[i] & 0xfc);
      //Serial.write((char)((samples[i])<< 4));
      //Serial.write((char)((samples[i])>> 4));
    }
    sample = 0;
    scLastSa = micros() + scPeriod;
  }
}

unsigned long period(uint8_t pin, uint8_t state)
{
  //edited pulseInlong() function for period length with 10s timeout
  uint8_t Bit = digitalPinToBitMask(pin);
  uint8_t port = digitalPinToPort(pin);
  uint8_t stateMask = (state ? Bit : 0);

  unsigned long startMicros = micros();

  // wait for requested polarity pulse end
  while ((*portInputRegister(port) & Bit) == stateMask) {
    if (micros() - startMicros > 10000000)
      return 0;
  }

  // wait for opposite requested polarity pulse end
  while ((*portInputRegister(port) & Bit) != stateMask) {
    if (micros() - startMicros > 1000000)
      return 0;
  }

  unsigned long start = micros();
  // wait for requested polarity pulse end & measuring
  while ((*portInputRegister(port) & Bit) == stateMask) {
    if (micros() - start > 1000000)
      return 0;
  }
  cntDuty = micros() - start;
  //wait for opposite polarity pulse end & measuring
  while ((*portInputRegister(port) & Bit) != stateMask) {
    if (micros() - start > 1000000)
      return 0;
  }
  long ret = micros() - start;
  return ret;
}
void cntLoop() {
  if (counting && (scLastSa < micros())) {
    cntPeriod = period(5, HIGH);
    //if(cntPeriod>5000) cntPeriod = freq();
    //if(cntPeriod){//send measured data
    Serial.write(0xFF); Serial.write(CHCNT); Serial.write(12); Serial.write(0);
    Serial.write(cntFreq[0]); Serial.write(cntFreq[1]); Serial.write(cntFreq[2]); Serial.write(cntFreq[3]);
    Serial.write(cntPeC[0]); Serial.write(cntPeC[1]); Serial.write(cntPeC[2]); Serial.write(cntPeC[3]);
    Serial.write(cntDuC[0]); Serial.write(cntDuC[1]); Serial.write(cntDuC[2]); Serial.write(cntDuC[3]);
    //}
    scLastSa = 400000 + micros();
  }
}
